/**
 * Betfair: Exchange Streaming API
 * API to receive streamed updates. This is an ssl socket connection of CRLF delimited json messages (see RequestMessage & ResponseMessage)
 *
 * OpenAPI spec version: 1.0.1423
 * Contact: bdp@betfair.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package com.betfair.esa.swagger.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;


/**
 * OrderSubscriptionMessage
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2020-07-08T14:44:27.518+08:00")
public class OrderSubscriptionMessage extends RequestMessage  {
  @SerializedName("segmentationEnabled")
  private Boolean segmentationEnabled = null;

  @SerializedName("orderFilter")
  private OrderFilter orderFilter = null;

  @SerializedName("clk")
  private String clk = null;

  @SerializedName("heartbeatMs")
  private Long heartbeatMs = null;

  @SerializedName("initialClk")
  private String initialClk = null;

  @SerializedName("conflateMs")
  private Long conflateMs = null;

  public OrderSubscriptionMessage segmentationEnabled(Boolean segmentationEnabled) {
    this.segmentationEnabled = segmentationEnabled;
    return this;
  }

   /**
   * Segmentation Enabled - allow the server to send large sets of data in segments, instead of a single block
   * @return segmentationEnabled
  **/
  @ApiModelProperty(example = "null", value = "Segmentation Enabled - allow the server to send large sets of data in segments, instead of a single block")
  public Boolean getSegmentationEnabled() {
    return segmentationEnabled;
  }

  public void setSegmentationEnabled(Boolean segmentationEnabled) {
    this.segmentationEnabled = segmentationEnabled;
  }

  public OrderSubscriptionMessage orderFilter(OrderFilter orderFilter) {
    this.orderFilter = orderFilter;
    return this;
  }

   /**
   * Optional filter applied to order subscription
   * @return orderFilter
  **/
  @ApiModelProperty(example = "null", value = "Optional filter applied to order subscription")
  public OrderFilter getOrderFilter() {
    return orderFilter;
  }

  public void setOrderFilter(OrderFilter orderFilter) {
    this.orderFilter = orderFilter;
  }

  public OrderSubscriptionMessage clk(String clk) {
    this.clk = clk;
    return this;
  }

   /**
   * Token value delta (received in MarketChangeMessage) that should be passed to resume a subscription
   * @return clk
  **/
  @ApiModelProperty(example = "null", value = "Token value delta (received in MarketChangeMessage) that should be passed to resume a subscription")
  public String getClk() {
    return clk;
  }

  public void setClk(String clk) {
    this.clk = clk;
  }

  public OrderSubscriptionMessage heartbeatMs(Long heartbeatMs) {
    this.heartbeatMs = heartbeatMs;
    return this;
  }

   /**
   * Heartbeat Milliseconds - the heartbeat rate (looped back on initial image after validation: bounds are 500 to 5000)
   * @return heartbeatMs
  **/
  @ApiModelProperty(example = "null", value = "Heartbeat Milliseconds - the heartbeat rate (looped back on initial image after validation: bounds are 500 to 5000)")
  public Long getHeartbeatMs() {
    return heartbeatMs;
  }

  public void setHeartbeatMs(Long heartbeatMs) {
    this.heartbeatMs = heartbeatMs;
  }

  public OrderSubscriptionMessage initialClk(String initialClk) {
    this.initialClk = initialClk;
    return this;
  }

   /**
   * Token value (received in initial MarketChangeMessage) that should be passed to resume a subscription
   * @return initialClk
  **/
  @ApiModelProperty(example = "null", value = "Token value (received in initial MarketChangeMessage) that should be passed to resume a subscription")
  public String getInitialClk() {
    return initialClk;
  }

  public void setInitialClk(String initialClk) {
    this.initialClk = initialClk;
  }

  public OrderSubscriptionMessage conflateMs(Long conflateMs) {
    this.conflateMs = conflateMs;
    return this;
  }

   /**
   * Conflate Milliseconds - the conflation rate (looped back on initial image after validation: bounds are 0 to 120000)
   * @return conflateMs
  **/
  @ApiModelProperty(example = "null", value = "Conflate Milliseconds - the conflation rate (looped back on initial image after validation: bounds are 0 to 120000)")
  public Long getConflateMs() {
    return conflateMs;
  }

  public void setConflateMs(Long conflateMs) {
    this.conflateMs = conflateMs;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    OrderSubscriptionMessage orderSubscriptionMessage = (OrderSubscriptionMessage) o;
    return Objects.equals(this.segmentationEnabled, orderSubscriptionMessage.segmentationEnabled) &&
        Objects.equals(this.orderFilter, orderSubscriptionMessage.orderFilter) &&
        Objects.equals(this.clk, orderSubscriptionMessage.clk) &&
        Objects.equals(this.heartbeatMs, orderSubscriptionMessage.heartbeatMs) &&
        Objects.equals(this.initialClk, orderSubscriptionMessage.initialClk) &&
        Objects.equals(this.conflateMs, orderSubscriptionMessage.conflateMs) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(segmentationEnabled, orderFilter, clk, heartbeatMs, initialClk, conflateMs, super.hashCode());
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class OrderSubscriptionMessage {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    segmentationEnabled: ").append(toIndentedString(segmentationEnabled)).append("\n");
    sb.append("    orderFilter: ").append(toIndentedString(orderFilter)).append("\n");
    sb.append("    clk: ").append(toIndentedString(clk)).append("\n");
    sb.append("    heartbeatMs: ").append(toIndentedString(heartbeatMs)).append("\n");
    sb.append("    initialClk: ").append(toIndentedString(initialClk)).append("\n");
    sb.append("    conflateMs: ").append(toIndentedString(conflateMs)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

